<?php
function master_class_tinymce_config( $init ) {
  	$init['wpautop'] = false;
	$init['indent'] = true;
	$init['tadv_noautop'] = true;
    return $init;
}
add_filter('tiny_mce_before_init', 'master_class_tinymce_config');
add_action( 'admin_menu', 'add_acme_options_page' );
function add_acme_options_page() {
	add_submenu_page('edit.php?post_type=mc-class', __('Email Customizer', 'mc-lan'), __('Email Customizer', 'mc-lan'), 'manage_options', 'email-template-customizer', 'dispaly_tes_email_customizer_html');
}

function dispaly_tes_email_customizer_html() {

	if ( ! current_user_can( 'manage_options' ) ) {
		return;
	}

 	if ( isset( $_GET['settings-updated'] ) ) {
		add_settings_error( 'tes_email_customizer_msg', 'tes_email_customizer_msg', __( 'Email Body Saved', 'woocommerce' ), 'updated' );
	}

	settings_errors( 'tes_email_customizer_msg' );

	?>
	<div class="wrap">
		<h1><?php echo esc_html( get_admin_page_title() ); ?></h1>
		<br/>
		<span id="mc-btn-shortcode" style="position: fixed;top: 10%;right: 0;z-index: 999; ">
			<img src="<?php echo MC_IMG; ?>/code.png"/>
		</span>

		<div id="mc-eml-Modal" class="mc-eml-modal" style="display: none;">


		  	<div class="mc-eml-modal-content">
		  	<span class="mc-eml-close">&times;</span>
		  		<header>
		  			<h2 style="text-align: center;font-size: 30px;border-bottom: 1px solid whitesmoke;padding-bottom: 10px; font-family: initial;">Shortcode Refference
		  			</h2>
		  		</header>
                <div style="
                    overflow: auto;
                    height: 350px;
                ">
		    	<table>
		    		<thead>
			    		<th>Variable</th>
			    		<th>Description</th>
			    	</thead>
			    	<tbody>
			    		<tr>
			    			<td>[CLASSNAME]</td>
			    			<td>For Class Name</td>
			    		</tr>
			    		<tr>
			    			<td>[LOGINURL]</td>
			    			<td>For Login URL</td>
			    		</tr>
			    		<tr>
			    			<td>[USERNAME]</td>
			    			<td>For User Name</td>
			    		</tr>
			    		<tr>
			    			<td>[USEREMAIL]</td>
			    			<td>For User Email Address</td>
			    		</tr>
			    		<tr>
			    			<td>[DISPLAYNAME]</td>
			    			<td>For User display name.</td>
			    		</tr>
			    		<tr>
			    			<td>[ACTURL]</td>
			    			<td>Activation link of the user.</td>
			    		</tr>
			    		<tr>
			    			<td>[RESETLINK]</td>
			    			<td>Reset password link of the user.</td>
			    		</tr>
			    		<tr>
			    			<td>[PAYRECEIPT]</td>
			    			<td>For Payment Receipt Details</td>
			    		</tr>
			    		
			    		<tr>
			    			<td>[AMOUNT]</td>
			    			<td>Amount paid for the transaction</td>
			    		</tr>
			    		<tr>
			    			<td>[PAIDWITH]</td>
			    			<td>The platform used for making the payment</td>
			    		</tr>
			    		<tr>
			    			<td>[DATE]</td>
			    			<td>The transaction date</td>
			    		</tr>
			    		<tr>
			    			<td>[INVOICELINK]</td>
			    			<td>For users dashboard link and for admin direct link to the order details backend</td>
			    		</tr>
			    		<tr>
			    			<td>[SITEURL]</td>
			    			<td>mail site url</td>
			    		</tr>
			    		<tr>
			    			<td>[DOMAIN]</td>
			    			<td>Main Domain for the site</td>
			    		</tr>
			    	</tbody>
			    	<tfoot>
			    		<th>Variable</th>
			    		<th>Description</th>
			    	</tfoot>
		    	</table>
		    	</div>
		  </div>

		</div>

		<div class="foxy-tabs">

		    <input type="radio" name="tabs" id="tab1" checked >
		    <label for="tab1">
		        <i><img src="<?php echo MC_IMG; ?>/user.png"/></i>
		        <span>User</span>
		    </label>

		    <input type="radio" name="tabs" id="tab2">
		    <label for="tab2">
		        <i><img src="<?php echo MC_IMG; ?>/admin.png"/></i>
		        <span>Admin</span>
		    </label>

		    <div id="tab-content1" class="tab-content">
		        <p>
		        <form action="options.php" method="post">
		        <?php
				do_settings_sections( 'tes-email-customizer_user' );
				settings_fields( 'tes-email-customizer_user' );
				submit_button();
		        ?>
		        </form>
		        </p>
		    </div>
		    <div id="tab-content2" class="tab-content">
		        <p>
		        <form action="options.php" method="post">
		        <?php
				do_settings_sections( 'tes-email-customizer_admin' );
				settings_fields( 'tes-email-customizer_admin' );
				submit_button();
		        ?>
		        </form>
		        </p>
		    </div>

		</div>

	</div>
	<script type="text/javascript">
		jQuery(".foxy-tabs-select").on('change',function(){
		    jQuery("#tab-content3 table").hide();
		    jQuery("#tab-content3 h2").hide();
		    var selected_val = jQuery(this).find(":selected").val();
		    jQuery("#wp-mc_eml_cust_body_"+selected_val+"-wrap").parents("table").show();

		});
		jQuery( document ).ready(function(){
		    var selected_val = jQuery(".foxy-tabs-select").find(":selected").val();
		    jQuery("#tab-content3 table").hide();
		    jQuery("#tab-content3 h2").hide();
		    jQuery("#wp-mc_eml_cust_body_"+selected_val+"-wrap").parents("table").show();
		});

		var modal = jQuery('#mc-eml-Modal');

		var btn = jQuery("#mc-btn-shortcode");

		var span = jQuery(".close")[0];

		jQuery("#mc-btn-shortcode").click(function(){
			jQuery("#mc-eml-Modal").show();
		});

		jQuery(".mc-eml-close").click(function(){
			jQuery("#mc-eml-Modal").hide();
		})

		window.onclick = function(event) {
		    if (event.target == modal) {
		       console.log("Bondho koro");

		    }
		}
	</script>
		<?php
}


add_action( 'admin_init', 'tes_email_customizer_part_three' );
function tes_email_customizer_part_three() {

	add_settings_section(
		'tes-email-customizer-settings-section-three',
		'Subscribed Class',
		'tes_email_customizer_part_three_message',
		'tes-email-customizer_user'
	);

	add_settings_field(
		'mc_eml_cust_sub_three',
		'Email Subject',
		'tes_email_customizer_input_sub_three',
		'tes-email-customizer_user',
		'tes-email-customizer-settings-section-three'
	);

	register_setting(
		'tes-email-customizer_user',
		'mc_eml_cust_sub_three'
	);

	add_settings_field(
		'mc_eml_cust_body_three',
		'Email Body',
		'tes_email_customizer_input_three',
		'tes-email-customizer_user',
		'tes-email-customizer-settings-section-three'
	);

	register_setting(
		'tes-email-customizer_user',
		'mc_eml_cust_body_three'
	);

}

function tes_email_customizer_input_three() {
	 $default_body = (get_option( 'mc_eml_cust_body_three' )) ? get_option( 'mc_eml_cust_body_three' ) : 'Hi [DISPLAYNAME],<br/><br/>You successfully subscribed <b>[CLASSNAME].</b><br/><p>Kindly <a href="[LOGINURL]">LogIn</a> to your account and access all classes.</p><p>Note that your classes are within the "My Courses" section.</p><br/><br/>Thanks,<br/>Class Makr.';

	$content_three = (get_option( 'mc_eml_cust_body_three' )) ? get_option( 'mc_eml_cust_body_three' ) : $default_body;
	wp_editor( $content_three, 'mc_eml_cust_body_three', $settings = array('textarea_rows'=> '10') );

	echo "<br/><i>Want to Send test email to Admin (".get_option('admin_email').")?  <a href='javascript:void(0);' data-id='three' class='button mc-test-mail-send'>Click Here</a></i><br/><br/>";
}
function tes_email_customizer_part_three_message() {
	echo "<i>After successfully subscribed a class, user get this email.</i>";
}
function tes_email_customizer_input_sub_three() {
	$sub_three = (get_option( 'mc_eml_cust_sub_three' )) ? get_option( 'mc_eml_cust_sub_three' ) : 'Subscribed Class: [CLASSNAME]';
	echo "<input type='text' name='mc_eml_cust_sub_three' id='mc_eml_cust_sub_three' value='".$sub_three."' style='width:100%;'/>";
}

add_action( 'admin_init', 'tes_email_customizer_part_four' );
function tes_email_customizer_part_four() {

	add_settings_section(
		'tes-email-customizer-settings-section-four',
		'Account Activation',
		'tes_email_customizer_part_four_message',
		'tes-email-customizer_user'
	);

	add_settings_field(
		'mc_eml_cust_sub_four',
		'Email Subject',
		'tes_email_customizer_input_sub_four',
		'tes-email-customizer_user',
		'tes-email-customizer-settings-section-four'
	);

	register_setting(
		'tes-email-customizer_user',
		'mc_eml_cust_sub_four'
	);

	add_settings_field(
		'mc_eml_cust_body_four',
		'Email Body',
		'tes_email_customizer_input_four',
		'tes-email-customizer_user',
		'tes-email-customizer-settings-section-four'
	);

	register_setting(
		'tes-email-customizer_user',
		'mc_eml_cust_body_four'
	);

}

function tes_email_customizer_part_four_message() {
	echo "<i>This email goes to User, with Site account activation link.</i>";
}

function tes_email_customizer_input_four() {
	$content_four = (get_option( 'mc_eml_cust_body_four' )) ? get_option( 'mc_eml_cust_body_four' ) : 'Hi [DISPLAYNAME],<br/><p>Active your account be clicking below link.<br/><b><a href="[ACTURL]">Activate Account</a></b></p><br/>Thanks,<br/>Class Makr';
	wp_editor( $content_four, 'mc_eml_cust_body_four', $settings = array('textarea_rows'=> '10') );
	echo "<br/><i>Want to Send test email to Admin (".get_option('admin_email').")?  <a href='javascript:void(0);' data-id='four' class='button mc-test-mail-send'>Click Here</a></i><br/><br/>";
}
function tes_email_customizer_input_sub_four() {
	$sub_four = (get_option( 'mc_eml_cust_sub_four' )) ? get_option( 'mc_eml_cust_sub_four' ) : 'Class Makr Account Activation';
	echo "<input type='text' name='mc_eml_cust_sub_four' id='mc_eml_cust_sub_four' value='".$sub_four."' style='width:100%;'/>";
}

add_action( 'admin_init', 'tes_email_customizer_part_one' );
function tes_email_customizer_part_one() {

	add_settings_section(
		'tes-email-customizer-settings-section-one',
		'Account Password Update',
		'tes_email_customizer_part_one_message',
		'tes-email-customizer_user'
	);

	add_settings_field(
		'mc_eml_cust_sub_one',
		'Email Subject',
		'tes_email_customizer_input_sub_one',
		'tes-email-customizer_user',
		'tes-email-customizer-settings-section-one'
	);

	register_setting(
		'tes-email-customizer_user',
		'mc_eml_cust_sub_three'
	);

	add_settings_field(
		'mc_eml_cust_body_one',
		'Email Body',
		'tes_email_customizer_input_one',
		'tes-email-customizer_user',
		'tes-email-customizer-settings-section-one'
	);

	register_setting(
		'tes-email-customizer_user',
		'mc_eml_cust_body_one'
	);

}

function tes_email_customizer_input_one() {
	$content_one = (get_option( 'mc_eml_cust_body_one' )) ? get_option( 'mc_eml_cust_body_one' ) : 'Hi [DISPLAYNAME],<br/><p>Your account password is updated.</p><p> You can now login with your new password.</p><br/><br/>Thanks,<br/>Class Makr.';
	wp_editor( $content_one, 'mc_eml_cust_body_one', $settings = array('textarea_rows'=> '10') );
	echo "<br/><i>Want to Send test email to Admin (".get_option('admin_email').")?  <a href='javascript:void(0);' data-id='one' class='button mc-test-mail-send'>Click Here</a></i><br/><br/>";
}
function tes_email_customizer_part_one_message() {
	echo "<i>After successfully update the password, user get this email.</i>";
}
function tes_email_customizer_input_sub_one() {
	$sub_one = (get_option( 'mc_eml_cust_sub_one' )) ? get_option( 'mc_eml_cust_sub_one' ) : 'Class Makr Account Password Updated';
	echo "<input type='text' name='mc_eml_cust_sub_one' id='mc_eml_cust_sub_one' value='".$sub_one."' style='width:100%;'/>";
}

add_action( 'admin_init', 'tes_email_customizer_part_two' );
function tes_email_customizer_part_two() {

	add_settings_section(
		'tes-email-customizer-settings-section-two',
		'Password Reset Email',
		'tes_email_customizer_part_two_message',
		'tes-email-customizer_user'
	);

	add_settings_field(
		'mc_eml_cust_sub_two',
		'Email Subject',
		'tes_email_customizer_input_sub_two',
		'tes-email-customizer_user',
		'tes-email-customizer-settings-section-two'
	);

	register_setting(
		'tes-email-customizer_user',
		'mc_eml_cust_sub_three'
	);

	add_settings_field(
		'mc_eml_cust_body_one',
		'Email Body',
		'tes_email_customizer_input_two',
		'tes-email-customizer_user',
		'tes-email-customizer-settings-section-two'
	);

	register_setting(
		'tes-email-customizer_user',
		'mc_eml_cust_body_two'
	);

}

function tes_email_customizer_input_two() {
	$content_two = (get_option( 'mc_eml_cust_body_two' )) ? get_option( 'mc_eml_cust_body_two' ) : 'Hi [DISPLAYNAME], <br/><p>Click the below link to reset your account password.<br/><a href="[RESETLINK]"><b>Reset Password</b></a></p><br/>Thanks,<br/>Class Makr.';
	wp_editor( $content_two, 'mc_eml_cust_body_two', $settings = array('textarea_rows'=> '10') );
	echo "<br/><i>Want to Send test email to Admin (".get_option('admin_email').")?  <a href='javascript:void(0);' data-id='two' class='button mc-test-mail-send'>Click Here</a></i><br/><br/>";
}
function tes_email_customizer_part_two_message() {
	echo "<i>After submit the forgot password form, user get this email.</i>";
}
function tes_email_customizer_input_sub_two() {
	$sub_two = (get_option( 'mc_eml_cust_sub_two' )) ? get_option( 'mc_eml_cust_sub_two' ) : 'Class Makr Account Password Reset';
	echo "<input type='text' name='mc_eml_cust_sub_two' id='mc_eml_cust_sub_two' value='".$sub_two."' style='width:100%;'/>";
}


add_action( 'admin_init', 'tes_email_customizer_part_six' );
function tes_email_customizer_part_six() {

	add_settings_section(
		'tes-email-customizer-settings-section-six',
		'WelCome Email',
		'tes_email_customizer_part_six_message',
		'tes-email-customizer_user'
	);

	add_settings_field(
		'mc_eml_cust_sub_six',
		'Email Subject',
		'tes_email_customizer_input_sub_six',
		'tes-email-customizer_user',
		'tes-email-customizer-settings-section-six'
	);

	register_setting(
		'tes-email-customizer_user',
		'mc_eml_cust_sub_six'
	);

	add_settings_field(
		'mc_eml_cust_body_six',
		'Email Body',
		'tes_email_customizer_input_six',
		'tes-email-customizer_user',
		'tes-email-customizer-settings-section-six'
	);

	register_setting(
		'tes-email-customizer_user',
		'mc_eml_cust_body_six'
	);

}

function tes_email_customizer_part_six_message() {
	echo "<i>This WelCome email goes to User after activating their account.</i>";
}

function tes_email_customizer_input_six() {
	$content_six = (get_option( 'mc_eml_cust_body_six' )) ? get_option( 'mc_eml_cust_body_six' ) : 'Hi [DISPLAYNAME],<br/> <p>Congratulations on creating an account with us. Kindly find your login details below.</p> <br/>Login with Username: [USERNAME]<br/>Password was created at signup<br/><p><a href="[LOGINURL]" target="_blank;">Login to your account using this link</a></p>Thanks,<br/>Class Makr.';
	wp_editor( $content_six, 'mc_eml_cust_body_six', $settings = array('textarea_rows'=> '10') );
	echo "<br/><i>Want to Send test email to Admin (".get_option('admin_email').")?  <a href='javascript:void(0);' data-id='six' class='button mc-test-mail-send'>Click Here</a></i><br/><br/>";

}
function tes_email_customizer_input_sub_six() {
	$sub_six = (get_option( 'mc_eml_cust_sub_six' )) ? get_option( 'mc_eml_cust_sub_six' ) : 'Class Makr WelCome Email';
	echo "<input type='text' name='mc_eml_cust_sub_six' id='mc_eml_cust_sub_six' value='".$sub_six."' style='width:100%;'/>";
}

add_action( 'admin_init', 'tes_email_customizer_part_seven' );
function tes_email_customizer_part_seven() {

	add_settings_section(
		'tes-email-customizer-settings-section-seven',
		'Subscribed Class',
		'tes_email_customizer_part_seven_message',
		'tes-email-customizer_admin'
	);

	add_settings_field(
		'mc_eml_cust_sub_seven',
		'Email Subject',
		'tes_email_customizer_input_sub_seven',
		'tes-email-customizer_admin',
		'tes-email-customizer-settings-section-seven'
	);

	register_setting(
		'tes-email-customizer_admin',
		'mc_eml_cust_sub_seven'
	);

	add_settings_field(
		'mc_eml_cust_body_seven',
		'Email Body',
		'tes_email_customizer_input_seven',
		'tes-email-customizer_admin',
		'tes-email-customizer-settings-section-seven'
	);

	register_setting(
		'tes-email-customizer_admin',
		'mc_eml_cust_body_seven'
	);

}

function tes_email_customizer_part_seven_message() {
	echo "<i>After successfully subscribed a class, admin get this email.</i>";
}

function tes_email_customizer_input_seven() {
    
    $default='Hi Admin,';
    $default.='<br>Congratulations! A new person has signed up for your class.';
    $default.='<br><strong>Customer name:</strong> [DISPLAYNAME]';
    $default.='<br><strong>Email:</strong> [USEREMAIL]';
    $default.='<br><strong>Class name:</strong> [CLASSNAME]';
    $default.='<br><strong>Amount paid:</strong> [AMOUNT]';
    $default.='<br><strong>Paid with:</strong> [PAIDWITH]';
    $default.='<br>Date [DATE]';
                
    $default.='<br>Click <a href="[INVOICELINK]">here</a> to see the customer’s details. ';
    $default.='<br><a href="[SITEURL]">[DOMAIN]</a>';
        
	$content_seven = (get_option( 'mc_eml_cust_body_seven' )) ? get_option( 'mc_eml_cust_body_seven' ) : $default;
	wp_editor( $content_seven, 'mc_eml_cust_body_seven', $settings = array('textarea_rows'=> '10') );
	echo "<br/><i>Want to Send test email to Admin (".get_option('admin_email').")?  <a href='javascript:void(0);' data-id='seven' class='button mc-test-mail-send'>Click Here</a></i><br/><br/>";

}
function tes_email_customizer_input_sub_seven() {
	$sub_seven = (get_option( 'mc_eml_cust_sub_seven' )) ? get_option( 'mc_eml_cust_sub_seven' ) : 'Class Makr Subscription Notification';
	echo "<input type='text' name='mc_eml_cust_sub_seven' id='mc_eml_cust_sub_seven' value='".$sub_seven."' style='width:100%;'/>";
}

add_action( 'admin_footer', 'add_jquery_for_test_email' );
function add_jquery_for_test_email(){
	?>
	<script type="text/javascript">
		var $ =jQuery.noConflict();
		$(".mc-test-mail-send").on('click',function(){
	        $(this).html("Please wait...");
	        var dataid = $(this).attr('data-id');

	        var subject = $("#mc_eml_cust_sub_"+dataid).val();
	        var body = $("#mc_eml_cust_body_"+dataid).val();

	        if( !subject ){
	        	$("#mc_eml_cust_sub_"+dataid).focus();
	        	return false;
	        }
	        if( !body ){
	        	$("#mc_eml_cust_body_"+dataid).focus();
	        	return false;
	        }

	        var ajaxurl = '<?php echo admin_url( 'admin-ajax.php' ); ?>';
	        var data = {
	            action: 'mc_send_test_email',
	            subject: subject,
	            body: body
	        };
	        $.post( ajaxurl, data, function( response ) {
	            alert("Email Send");
	            $(".mc-test-mail-send").html("Click Here");
	        });
	    });
	</script>
	<?php
}
add_action( 'wp_ajax_mc_send_test_email', 'mc_send_test_email_callback' );
function mc_send_test_email_callback(){
	$body = $_POST['body'];

	$body = str_replace("[CLASSNAME]", "CLASS_NAME", $body);
	$body = str_replace("[LOGINURL]", "LOGIN_URL", $body);
	$body = str_replace("[USERNAME]", "USER_NAME", $body);
	$body = str_replace("[USEREMAIL]", "USER_EMAIL", $body);
	$body = str_replace("[DISPLAYNAME]", "DISPLAY_NAME", $body);
	$body = str_replace("[ACTURL]", "ACT_URL", $body);
	$body = str_replace("[RESETLINK]", "RESET_LINK", $body);

	$body = MC_Email_Template_Controller::general_email_template($body);

	$subject = $_POST['subject'];
	$subject = str_replace("[CLASSNAME]", "CLASS_NAME", $subject);
	$subject = str_replace("[LOGINURL]", "LOGIN_URL", $subject);
	$subject = str_replace("[USERNAME]", "USER_NAME", $subject);
	$subject = str_replace("[USEREMAIL]", "USER_EMAIL", $subject);
	$subject = str_replace("[DISPLAYNAME]", "DISPLAY_NAME", $subject);
	$subject = str_replace("[ACTURL]", "ACT_URL", $subject);
	$subject = str_replace("[RESETLINK]", "RESET_LINK", $subject);

	$headers = "MIME-Version: 1.0" . "\r\n";
	$headers .= "Content-type:text/html;charset=UTF-8";

	$to = get_option('admin_email');

	echo wp_mail( $to, $subject, $body, $headers );
	exit;
}