(function( $ ) {
    jQuery("#upload_new_documents").click(function(){
        open_media_popup();
        return false;
    });

    function open_media_popup(){
        custom_uploader = wp.media.frames.file_frame = wp.media({
            title: 'Choose Dcuments',
            button: {
                text: 'Add'
            },
            multiple: true
        });
        

        custom_uploader.on('select', function() {
            attachment = custom_uploader.state().get('selection').toJSON();
            for (var i=0; i<attachment.length; i++) {
                var url = attachment[i].url;
                jQuery("#document_list").append('<p><span class="dashicons dashicons-dismiss delete-documents"></span>&nbsp;&nbsp;&nbsp;<a href='+attachment[i].url+' download>'+attachment[i].title+'</a><input type="hidden" name="mc_documents[]" value="'+attachment[i].id+'" /></p><br/>');
            }
            jQuery(".delete-documents").on('click',function(){
                jQuery(this).parent().remove();
            });
           
        });
        custom_uploader.open();
    }
    jQuery(".delete-documents").on('click',function(){
        jQuery(this).parent().remove();
    });


    jQuery("#mc-class-upload-button").click(function(){
        custom_uploader = wp.media.frames.file_frame = wp.media({
            title: 'Choose Image',
            button: {
                text: 'Add'
            },
            multiple: false
        });
        

        custom_uploader.on('select', function() {
            attachment = custom_uploader.state().get('selection').toJSON();
            for (var i=0; i<attachment.length; i++) {
                var url = attachment[i].url;
                jQuery("#mc-cat-display").html('<p><a href='+attachment[i].url+' download>'+attachment[i].title+'</a></p>');
                jQuery("#term_meta_mc_cat_cover_term_meta").val(attachment[i].id);
            }
            
        });
        custom_uploader.open();
        return false;
    });

    jQuery("#mc_cat_vid_thumb_image_type_term_meta").on('change',function(){
        var choice = jQuery(this).val();
        //console.log(choice);
        jQuery("#mc_cat_vid_thumb_image_term_meta_featured").hide();
        jQuery("#mc_cat_vid_thumb_image_term_meta_display").hide();
        if( choice == 'new' ){
            custom_uploader = wp.media.frames.file_frame = wp.media({
                title: 'Choose Image',
                button: {
                    text: 'Add'
                },
                multiple: false
            });
            

            custom_uploader.on('select', function() {
                attachment = custom_uploader.state().get('selection').toJSON();
                for (var i=0; i<attachment.length; i++) {
                    var url = attachment[i].url;
                    jQuery("#mc_cat_vid_thumb_image_term_meta_new").html('<p id="mc_cat_vid_thumb_image_term_meta_display"><a href='+attachment[i].url+' download>'+attachment[i].title+'</a><span class="dashicons dashicons-dismiss delete-video-feat-image" style="color: red;cursor: pointer;display: inline-block;text-decoration: none;"></span></p>');
                    jQuery("#mc_cat_vid_thumb_image_term_meta").val(attachment[i].id);
                    jQuery("#mc_cat_vid_thumb_image_term_meta_display").show();
                }
                jQuery(".delete-video-feat-image").on('click',function(){
                    jQuery(this).parent().html(null);
                    jQuery("#mc_cat_vid_thumb_image_term_meta").val(null);
                    jQuery('#mc_cat_vid_thumb_image_type_term_meta option:selected').attr("selected",null);
                    jQuery("#mc_cat_vid_thumb_image_type_term_meta option[value='default']").attr("selected", "selected");
                });
                
            });
            custom_uploader.open();
            return false;
        }
        if( choice == 'featured' ){
            jQuery("#mc_cat_vid_thumb_image_term_meta_featured").show();
        }
    });
    jQuery(".delete-video-feat-image").on('click',function(){
        jQuery(this).parent().html(null);
        jQuery("#mc_cat_vid_thumb_image_term_meta").val(null);
        jQuery('#mc_cat_vid_thumb_image_type_term_meta option:selected').attr("selected",null);
        jQuery("#mc_cat_vid_thumb_image_type_term_meta option[value='default']").attr("selected", "selected");
    });

    jQuery("#mc-bundle-package-upload-button").click(function(){
        custom_uploader = wp.media.frames.file_frame = wp.media({
            title: 'Choose Image',
            button: {
                text: 'Add'
            },
            multiple: false
        });
        

        custom_uploader.on('select', function() {
            attachment = custom_uploader.state().get('selection').toJSON();
            for (var i=0; i<attachment.length; i++) {
                var url = attachment[i].url;
                jQuery("#mc_cls_bundle_image_prev").html('<a href='+attachment[i].url+' download>'+attachment[i].title+'</a>');
                jQuery("#mc_cls_bundle_image").val(attachment[i].id);
            }
            
        });
        custom_uploader.open();
        return false;
    });
    jQuery("#add-qstn-ans").click(function(){
        var html = '';
        var count = jQuery("#total-ques-ans-number").val();

        html += '<div class="question-answer-set" id="question-answer-set-'+count+'">\
                    <span class="question"><input type="text" name="ques_ans['+count+'][question]" value="" placeholder="What is your question?"></span>\
                    <div class="answer" id="answer-set-'+count+'">\
                        <p>\
                            <input type="text" name="ques_ans['+count+'][answer][1][text]" value="" placeholder="What is your answer option?">\
                            <span>, this answer is a </span>\
                            <select name="ques_ans['+count+'][answer][1][is_right]">\
                                 <option value="yes">Correct Answer</option>\
                                 <option value="no">Incorrect Answer</option>\
                            </select>\
                        </p>\
                        <p>\
                            <input type="text" name="ques_ans['+count+'][answer][2][text]" value="" placeholder="What is your answer option?">\
                            <span>, this answer is a </span>\
                            <select name="ques_ans['+count+'][answer][2][is_right]">\
                                 <option value="yes">Correct Answer</option>\
                                 <option value="no">Incorrect Answer</option>\
                            </select>\
                        </p>\
                    </div>\
                    <span class="mc-class-delete-qans dashicons dashicons-trash" style="float: right; cursor: pointer;"></span>\
                   <a class="add-answer" href="javascript:void(0);" data-id="'+count+'" current-answer-id="2">Add new answer</a>\
                </div>';

        jQuery(".question-answer").append(html)
        count = parseInt(count)+1;
        jQuery("#total-ques-ans-number").val(count);
        remove();
        add_answer_sets();

    });
    function add_answer_sets(){
        jQuery(".add-answer").click(function(){
            var set_id = jQuery(this).attr('data-id');
            var curr_ans_id = jQuery(this).attr('current-answer-id');
            curr_ans_id = parseInt(curr_ans_id)+1;
            var answer_html = '<p style="margin-left: 13px;">\
                            <input type="text" name="ques_ans['+set_id+'][answer]['+curr_ans_id+'][text]" value="" placeholder="What is your answer option?">\
                            <span>, this answer is a </span>\
                            <select name="ques_ans['+set_id+'][answer]['+curr_ans_id+'][is_right]">\
                                 <option value="yes">Correct Answer</option>\
                                 <option value="no">Incorrect Answer</option>\
                            </select>\
                            <span onclick="jQuery(this).parent().remove();" class="dashicons dashicons-no-alt remove-answer" style="cursor: pointer; color: red; font-style: normal; font-size: 21px; vertical-align: middle;"></span>\
                        </p>';
            jQuery("#answer-set-"+set_id).append(answer_html);
            jQuery(this).attr('current-answer-id',curr_ans_id);
        });

    }
    add_answer_sets();

    jQuery("#add-checkbox-qstn-ans").click(function(){
        var html = '';
        var count = jQuery("#total-checkbox-ques-ans-number").val();
        html += '<div class="checkbox-question-answer-set" id="checkbox-question-answer-set-'+count+'">\
                <span class="question"><input type="text" name="checkbox_ques_ans['+count+'][question]" value="" placeholder="What is your question?"></span>\
                <div class="answer">\
                    <p>\
                        <input type="text" name="checkbox_ques_ans['+count+'][answer1]" value="" placeholder="What is your answer option?">\
                    </p>\
                    <p>\
                        <input type="text"  name="checkbox_ques_ans['+count+'][answer2]" value="" placeholder="What is your answer option?">\
                    </p>\
                    <p>\
                        <input type="text" name="checkbox_ques_ans['+count+'][answer3]" value="" placeholder="What is your answer option?">\
                    </p>\
                    <p>\
                        <input type="text" name="checkbox_ques_ans['+count+'][answer4]" value="" placeholder="What is your answer option?">\
                    </p>\
                </div>\
                <span class="mc-class-delete-checkbox-qans dashicons dashicons-trash" style="float: right; cursor: pointer;"></span>\
            </div>';
        jQuery(".checkbox-question-answer").append(html)
        count = parseInt(count)+1;
        jQuery("#total-checkbox-ques-ans-number").val(count);
        remove();

    });
    function remove(){
        jQuery(".mc-class-delete-qans, .mc-class-delete-checkbox-qans").click(function(){
            var r = confirm("Are you sure?");
            if (r == true) {
                jQuery(this).parent().remove();
            } else {
                return false;
            }
            
        });
    }

    jQuery(".post-type-mc-class").find("#page_template").find("option").eq(0).remove();

   
    remove();

    jQuery("#_mc_lesson_vid_thumb_image_type_term_meta").on('change',function(){
        var choice = jQuery(this).val();
        //console.log(choice);
        jQuery("#_mc_lesson_vid_thumb_image_term_meta_featured").hide();
        jQuery("#_mc_lesson_vid_thumb_image_term_meta_display").hide();
        if( choice == 'new' ){
            custom_uploader = wp.media.frames.file_frame = wp.media({
                title: 'Choose Image',
                button: {
                    text: 'Add'
                },
                multiple: false
            });
            

            custom_uploader.on('select', function() {
                attachment = custom_uploader.state().get('selection').toJSON();
                for (var i=0; i<attachment.length; i++) {
                    var url = attachment[i].url;
                    jQuery("#_mc_lesson_vid_thumb_image_term_meta_new").html('<p id="_mc_lesson_vid_thumb_image_term_meta_display"><a href='+attachment[i].url+' download>'+attachment[i].title+'</a><span class="dashicons dashicons-dismiss delete-video-feat-image-lesson" style="color: red;cursor: pointer;display: inline-block;text-decoration: none;"></span></p>');
                    jQuery("#_mc_lesson_vid_thumb_image_term_meta").val(attachment[i].id);
                    jQuery("#_mc_lesson_vid_thumb_image_term_meta_display").show();
                }
                jQuery(".delete-video-feat-image-lesson").on('click',function(){
                    jQuery(this).parent().html(null);
                    jQuery("#_mc_lesson_vid_thumb_image_term_meta").val(null);
                    jQuery('#_mc_lesson_vid_thumb_image_type_term_meta option:selected').attr("selected",null);
                    jQuery("#_mc_lesson_vid_thumb_image_type_term_meta option[value='default']").attr("selected", "selected");
                });
                
            });
            custom_uploader.open();
            return false;
        }
        if( choice == 'featured' ){
            jQuery("#_mc_lesson_vid_thumb_image_term_meta_featured").show();
        }
    });
    jQuery(".delete-video-feat-image-lesson").on('click',function(){
        jQuery(this).parent().html(null);
        jQuery("#_mc_lesson_vid_thumb_image_term_meta").val(null);
        jQuery('#_mc_lesson_vid_thumb_image_type_term_meta option:selected').attr("selected",null);
        jQuery("#_mc_lesson_vid_thumb_image_type_term_meta option[value='default']").attr("selected", "selected");
    });
})( jQuery );

