<?php
class Master_CSS_JS_Controller
{
	
	public function __construct()
	{
		add_action( 'admin_enqueue_scripts', array($this,'add_css'), 10, 1 );
		add_action( 'admin_enqueue_scripts', array($this,'add_js'), 10, 1 );
		add_action( 'admin_head-edit-tags.php', array($this,'remove_parent_category_from_list'));
		add_action( 'admin_head-term.php', array($this,'remove_parent_category_from_edit'));
		add_action( 'admin_head-post-new.php', array($this,'remove_parent_category_from_post'));
		add_action( 'wp_enqueue_scripts', array($this,'add_front_css'), 10, 1 );

	}
	public static function add_front_css(){
		//wp_enqueue_style( 'mc-front-css-2',MC_CSS.'/print.css', array(), '1.1' );
		wp_enqueue_style( 'mc-front-css-3',MC_CSS.'/font-awesome.min.css', array(), '1.1' );
		wp_enqueue_style( 'mc-front-css-4',MC_CSS.'/mc-front-style.css', array(), '1.1' );
		wp_register_style( 'mc-front-css-5', false );
        wp_enqueue_style( 'mc-front-css-5' );
        $h3Clr=get_option('mc_acc_text_h3_clr') ? get_option('mc_acc_text_h3_clr') : '';
        $h3Clr=(strlen($h3Clr)>0?'.mc_class_cat_box .mc_class_H3,.mcLessonh3,.mcContMainWrapper h3,.mcAlreadyAccount,.mcRegFormLegend,.mcCouponTitle,.mcCouponOpenTag,.mc_class_post-title{ color: '.$h3Clr.' !important; }.mCavailableMainCaption h3,.mcClassSingleCoverTxt h3{color:#fff !important;}':'');
        $h2Clr=get_option('mc_acc_text_h2_clr') ? get_option('mc_acc_text_h2_clr') : '';
        $h2Clr=(strlen($h2Clr)>0?'.mc_class_H2,.mcLessonGradH2,.mcLessonh2,.mcContMainWrapper h2,.mcLoginFormTitle,.mcLessonBeforeContentTitle{ color: '.$h2Clr.' !important; }':'');
        $txtClr=get_option('mc_acc_text_clr') ? get_option('mc_acc_text_clr') : '';
        $txtClr=(strlen($txtClr)>0?'.mcContMainWrapper,.mcLessonContentDiv p,.mcText,.mcRegRightPriceArea,.mcOrderSummaryCourseAddtnlDetails p,.class-makr-msg,.class-makr-payment-succ-msg{ color: '.$txtClr.' !important; }':'');
        $h1clr=get_option('mc_acc_text_h1_clr') ? get_option('mc_acc_text_h1_clr') : '#bfbfbf;';
        $h1clr=(strlen($h1clr)>0?'.mcRegFormTitle,.mcLoginFormTitle{ color: '.$h1clr.' !important; }':'');

        $videoBtnbackColor=get_option('mc_player_color_acent_back');
        $videoAccentColor=get_option('mc_player_color_acent');
        $videoBtnback=(strlen($videoBtnbackColor)>0?'.stellar_vp_playButtonPoster{background: '.$videoBtnbackColor.' !important;}':'');
        $videoAccent=(strlen($videoAccentColor)>0?$videoAccentColor:'#ffffff');
        $whistiaColor=(strlen($videoBtnback)>0?$videoBtnbackColor:'rgb(229, 2, 2)');
        $whistia='.mcWhistiaVideo .w-big-play-button  div{
                    background-color: '.$whistiaColor.'!important;
                    }
                    .mcWhistiaVideo .w-big-play-button svg polygon{fill:'.$videoAccent.'!important;}';

        $custom='';
        $custom.=$h3Clr.$h2Clr.$txtClr.$h1clr.$videoBtnback.$whistia;
        wp_add_inline_style( 'mc-front-css-5', $custom );
        
        
        if(is_single() && 'mc-class' == get_post_type())
	    {
	       $mc_cls_user_comments_lesson = (get_option('mc_cls_user_comments_lesson')) ? get_option('mc_cls_user_comments_lesson') : 'enable';
		    if( $mc_cls_user_comments_lesson == 'enable' ){
		        $postID=get_the_ID();
		        $vid_type = get_post_meta($postID,'_mc_lesson_tutorial_video_type',true);
		        if($vid_type=='youtube-live')
		        {
    		        $scheduleType=get_post_meta($postID,'_schedule_live_video_class_makr',true);
                    if(strlen($scheduleType)>0)
    		        {
    		            if (time() >= $scheduleTime) 
    		            {
    		                 wp_enqueue_style( 'mc-chat-css',MC_CSS.'/mc-chat.css', array(), '1.1' );
    		                 wp_enqueue_script( 'mc-chat-js', MC_JS . '/mc-chat-js.js', array( 'jquery' ) );
		                     wp_localize_script( 'mc-chat-js', 'classMakrControl',
                                array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ,'loader' =>MC_IMG.'/5.gif' ,'default'=>MC_IMG.'/default.jpeg','postId'=>get_the_ID(),'user'=>get_current_user_id()) );     
    		            }
    		        }
		        }

            }
	           
	            
	    }
	

	}

	public static function add_css(){
		?>
		<style>
			#menu-posts-mc-class .menu-icon-mc-class .wp-menu-image img{width: 82%;padding: 3px 0 0;}
		</style>
		<?php
		global $pagenow;
		if(isset($_GET['taxonomy']) && $_GET['taxonomy']=='mc-class-category')
		{
			wp_enqueue_style( 'mc-admin-css-1',MC_CSS.'/mc-admin.css', array(), '1.1' );
		}
		$allowedPostTypes=array('mc-class','mc_class_payment','mc_class_coupon');
		if (isset($_GET['post_type']) && in_array($_GET['post_type'], $allowedPostTypes) )
        {
        	wp_enqueue_style( 'mc-admin-css-1',MC_CSS.'/mc-admin.css', array(), '1.1' );
        }
        if($pagenow==='users.php' && isset($_GET['role']) && $_GET['role']=='mc_learner')
        {
        	wp_enqueue_style( 'mc-admin-css-1',MC_CSS.'/mc-admin.css', array(), '1.1' );
        }
		$flags=array("post-new.php","post.php");
		if ( in_array($pagenow, $flags)  && isset($_GET['post']) &&  in_array(get_post_type( $_GET['post'] ), $allowedPostTypes) )
        {
        	wp_enqueue_style( 'mc-admin-css-1',MC_CSS.'/mc-admin.css', array(), '1.1' );
        }
		
	}

	public static function add_js(){
		global $pagenow;
		if(isset($_GET['taxonomy']) && $_GET['taxonomy']=='mc-class-category')
		{
			wp_enqueue_media();
			wp_register_script('classmakr-mc-admin-js1', MC_JS.'/mc-admin.js', array('jquery'),'1.1', true);
			wp_enqueue_script('classmakr-mc-admin-js1');
		}
		$allowedPostTypes=array('mc-class','mc_class_payment','mc_class_coupon');
		if (isset($_GET['post_type']) && in_array($_GET['post_type'], $allowedPostTypes) )
        {
        	wp_enqueue_media();
			wp_register_script('classmakr-mc-admin-js1', MC_JS.'/mc-admin.js', array('jquery'),'1.1', true);
			wp_enqueue_script('classmakr-mc-admin-js1');
        }
        if($pagenow==='users.php' && isset($_GET['role']) && $_GET['role']=='mc_learner')
        {
        	wp_enqueue_media();
			wp_register_script('classmakr-mc-admin-js1', MC_JS.'/mc-admin.js', array('jquery'),'1.1', true);
			wp_enqueue_script('classmakr-mc-admin-js1');
        }
		$flags=array("post-new.php","post.php");
		if ( in_array($pagenow, $flags)  && isset($_GET['post']) &&  in_array(get_post_type( $_GET['post'] ), $allowedPostTypes) )
        {
        	wp_enqueue_media();
			wp_register_script('classmakr-mc-admin-js1', MC_JS.'/mc-admin.js', array('jquery'),'1.1', true);
			wp_enqueue_script('classmakr-mc-admin-js1');
        }
		
	}

	public static function remove_parent_category_from_list(){
		if ( 'mc-class-category' != $_GET['taxonomy'] )
        	return;
	    ?>
	        <script type="text/javascript">
	            jQuery(document).ready(function($)
	            {     
	                $('label[for=parent]').parent().remove();       
	            });
	        </script>
	    <?php
	}

	public static function remove_parent_category_from_edit(){
		if ( 'mc-class-category' != $_GET['taxonomy'] )
        	return;
	    ?>
	        <script type="text/javascript">
	            jQuery(document).ready(function($)
	            {     
	                $('label[for=parent]').parent().parent().remove();       
	            });
	        </script>
	    <?php
	}
	public static function remove_parent_category_from_post(){
		if ( 'mc-class' != $_GET['post_type'] )
        	return;
        ?>
	        <script type="text/javascript">
	            jQuery(document).ready(function($)
	            {     
	                $('#newmc-class-category_parent').remove();       
	            });
	        </script>
	    <?php
	}
}