<?php
class Master_Lesson_After_Content
{

	public function __construct()
	{
		add_filter( 'the_content', array($this,'add_after_content') );
		add_action('wp_ajax_classMakrLiveChat',[$this,'classMakrLiveChat']);
		add_action('wp_ajax_nopriv_classMakrLiveChat',[$this,'classMakrLiveChat']);
		add_action('wp_ajax_classMakrLoadOlder',[$this,'classMakrLoadOlder']);
		add_action('wp_ajax_nopriv_classMakrLoadOlder',[$this,'classMakrLoadOlder']);
	}
	public function classMakrLoadOlder()
	{
	    global $wpdb;
	    $postID= $_POST['postID'];
        $thread=array();
        $pos=$_POST['pos'];
        $pos=$pos-1;
        $offset=($pos>10?$pos-10:0);
        $commentsArgs=array('post_id' => $postID, 'orderby'=>'comment_date','order' => 'ASC','number'=>10,'offset'=>$offset);
        $comments_query = new WP_Comment_Query;
        $comments = $comments_query->query( $commentsArgs );
		$count=count($comments);
		if($count>0)
		{
		    $text=array();
		    foreach ($comments as $line_num => $comment)
            {
        		$authorData=get_user_by('email',$comment->comment_author_email);
	             $avatarID = get_user_meta( $authorData->ID, '_classmakr_avatar_id' , true );
		         $gravatar_url = ($avatarID!=NULL?wp_get_attachment_image_src( $avatarID, 'class-makr-avatar')[0]:MC_IMG.'/default.jpeg');
		 
		         if(is_super_admin($authorData->ID))
		         {
		             $fname = get_user_meta( $authorData->ID, 'first_name', true );
		             $fname=(strlen($fname)>0?$fname:'');
		             $lname = get_user_meta( $authorData->ID, 'last_name', true );
		             $lname=(strlen($lname)>0?$lname:'');
		             $author=$fname.' '.$lname;
		         }
		         else
		         {
		             if(in_array( 'administrator', (array) $authorData->roles ))
			         {
			             $email=$comment->comment_author_email;
			             $res=$wpdb->get_var("SELECT title FROM `".$wpdb->get_blog_prefix(1)."signups` WHERE user_email='".$email."' order by signup_id desc limit 1");
                         $author=$res;
			         }
			         else
			         {
			             $author=$comment->comment_author;
			         }
		         }
		         
		         
		         
                 $authorRole=(in_array( 'administrator', (array) $authorData->roles )?'Administrator':'');
			     $commentMsg=$comment->comment_content;
			     $time=Common_Functions_Controller::humanTiming( strtotime($comment->comment_date) ).' ago';
			     $offset++;
		         $temp=array('line'=>$offset,'avatar'=>$gravatar_url,'author'=>$author,'role'=>$authorRole,'msg'=>$commentMsg,'time'=>$time);
		         
			     $text[] =  $temp;
                           
            }
            $thread['messages'] = $text;
            echo json_encode($thread);
		}
		else
		{
		    echo 'empty';
		}
        global $wpdb;
        die;
	}
    public function classMakrLiveChat()
    {
        $function = $_POST['functionName'];
        $postID= $_POST['postID'];
        $thread=array();
        global $wpdb;
        switch($function) {
    	
    	 case('update'):
    	     $state = $_POST['state'];
    	     $lastTime=$_POST['lastTime'];
    	     $total=$wpdb->get_var("SELECT count(comment_ID) as c FROM `".$wpdb->prefix."comments` where comment_post_ID=".$postID);
    	     $page=ceil($total/10);
    	     $items_per_page=10;
    	     $offset = ($page - 1) * $items_per_page;
    	     $diff=$total-$offset;
    	     $tempDiff=($diff<10?10-$diff:$diff);
    	     $offset=($diff<10?$offset-$tempDiff:$offset);
    	     $commentsArgs=array('post_id' => $postID, 'orderby'=>'comment_date','order' => 'ASC');
    	     if(empty($state))
    	     {
    	         if($page>3)
    	         {
    	             $commentsArgs['number']=10;
    	             $commentsArgs['offset']=$offset;
    	         }
    	         
    	     }
    	     else
    	     {
    	           if($page>3)
    	           {
                       $offset=$state;  	              
    	               $commentsArgs['offset']=$offset;
    	           }
    	     }
    	   //  $comments = get_comments($commentsArgs);
    	     $comments_query = new WP_Comment_Query;
             $comments = $comments_query->query( $commentsArgs );
			  $count=count($comments);
			  if($state == $count){
        		 $thread['state'] = $state;
        		 $thread['messages'] = false;
        		 $thread['lastTime'] =$lastTime;
        		 
        		 }
        		 else
        		 {
        		     $text= array();
        		     if(empty($state))
        		     {
        		         $thread['state']=$total;
        		     }
        		     else
        		     {
        		         $thread['state'] = $state + count($comments) - $state;
        		     }
        		     
        		      foreach ($comments as $line_num => $comment)
                      {
        			
        				  if($line_num >= $state){
    				         $authorData=get_user_by('email',$comment->comment_author_email);
        		             $avatarID = get_user_meta( $authorData->ID, '_classmakr_avatar_id' , true );
        			         $gravatar_url = ($avatarID!=NULL?wp_get_attachment_image_src( $avatarID, 'class-makr-avatar')[0]:MC_IMG.'/default.jpeg');
        			 
        			         if(is_super_admin($authorData->ID))
        			         {
        			             $fname = get_user_meta( $authorData->ID, 'first_name', true );
        			             $fname=(strlen($fname)>0?$fname:'');
        			             $lname = get_user_meta( $authorData->ID, 'last_name', true );
        			             $lname=(strlen($lname)>0?$lname:'');
        			             $author=$fname.' '.$lname;
        			         }
        			         else
        			         {
        			             if(in_array( 'administrator', (array) $authorData->roles ))
            			         {
            			             $email=$comment->comment_author_email;
            			             $res=$wpdb->get_var("SELECT title FROM `".$wpdb->get_blog_prefix(1)."signups` WHERE user_email='".$email."' order by signup_id desc limit 1");
                                     $author=$res;
            			         }
            			         else
            			         {
            			             $author=$comment->comment_author;
            			         }
        			         }
        			         
        			         
        			         
                             $authorRole=(in_array( 'administrator', (array) $authorData->roles )?'Administrator':'');
        				     $commentMsg=$comment->comment_content;
        				     $time=Common_Functions_Controller::humanTiming( strtotime($comment->comment_date) ).' ago';
        				     $offset++;
        			         $temp=array('line'=>$offset,'avatar'=>$gravatar_url,'author'=>$author,'role'=>$authorRole,'msg'=>$commentMsg,'time'=>$time);
        			         
        				     $text[] =  $temp;
        				     $lastTime=$comment->comment_date;
        				     $thread['lastTime']=$lastTime;
        				  }
                           
                        }
                        $thread['messages'] = $text;
        			 
        		     
        		 }
        	  
             break;
        	
        }
        echo json_encode($thread);
        die;
    }
	public static function add_after_content( $content ){
		if ( is_single() && 'mc-class' == get_post_type() ) {
			$pagination = '';
			$support_doc = '';
			$gradation = '';
			$comments = ''; 

			$mc_cls_pagination_lesson = (get_option('mc_cls_pagination_lesson')) ? get_option('mc_cls_pagination_lesson') : 'enable';
			if( $mc_cls_pagination_lesson == 'enable' ){
		        $pagination = Master_Lesson_After_Content::add_previous_pagination();
		        $pagination .= Master_Lesson_After_Content::add_next_pagination();
		    }

		    $support_doc = Master_Lesson_After_Content::supportive_documents();

		    $gradation = Master_Lesson_After_Content::gradation_system();
		    
		    $mc_cls_user_comments_lesson = (get_option('mc_cls_user_comments_lesson')) ? get_option('mc_cls_user_comments_lesson') : 'enable';
		    if( $mc_cls_user_comments_lesson == 'enable' ){
		        $vid_type = get_post_meta(get_the_ID(),'_mc_lesson_tutorial_video_type',true);
		        if($vid_type=='youtube-live')
		        {
    		        $scheduleType=get_post_meta(get_the_ID(),'_schedule_live_video_class_makr',true);
                    if(strlen($scheduleType)>0)
    		        {
    		            if (time() >= $scheduleTime) 
    		            {
    		                 $comments = Master_Lesson_After_Content::live_comment_system();         
    		            }
    		            else
    		            {
    		                 $comments = Master_Lesson_After_Content::comments_system();
    		            }
    		        }
    		        else
    		        {
    		            $comments = Master_Lesson_After_Content::comments_system();
    		        }
		        }
		        else
		        {
		            $comments = Master_Lesson_After_Content::comments_system();
		        }
            }

	        $after_content = $content.$support_doc.$gradation.$comments.$pagination.'</div></div>';
	        return $after_content;
	    } else {
	        return $content;
	    }
	}
	public static function add_previous_pagination(){
		return Navigation_Controller::previous_lesson_link_output();
	}
	public static function add_next_pagination(){
		return Navigation_Controller::next_lesson_link_output();
	}
	public static function supportive_documents(){
		ob_start();
		global $post;
    	setup_postdata($post);

        $post_id = get_the_ID();
		$documents = get_post_meta($post_id,'_mc_documents',true);
		if(is_array($documents)){
			?>
			<div id="mcLessonSuppDocList" class="mcLessonSuppDoc">
				<div class='mcLessonUl'>
					<?php
					foreach($documents as $doc_id){
						?>
						<div class='mcLessonLi'>
							<?php
								$mime_type = get_post_mime_type( $doc_id );
								switch ($mime_type) {
									case 'application/msword':
										$file_icon = '<span class="dashicons dashicons-editor-paste-word"></span>';
										break;
									case 'application/text':
										$file_icon = '<span class="dashicons dashicons-editor-paste-text"></span>';
										break;
									case 'application/pdf':
										$file_icon = '<span class="dashicons dashicons-book"></span>';
										break;
									case 'video/mp4':
										$file_icon = '<span class="dashicons dashicons-media-video"></span>';
										break;
									case 'application/zip':
										$file_icon = '<span class="dashicons dashicons-media-archive"></span>';
										break;
									case 'image/jpeg':
									case 'image/png':
									case 'image/jpg':
									case 'image/bmp':
									case 'image/gif':
										$file_icon = '<span class="dashicons dashicons-format-image"></span>';
										break;
									case 'text/plain':
										$file_icon = '<span class="dashicons dashicons-editor-paste-text"></span>';
										break;
									case 'audio/mpeg':
										$file_icon = '<span class="dashicons dashicons-media-audio"></span>';
										break;
									case 'application/vnd.ms-excel':
										$file_icon = '<span class="dashicons dashicons-media-spreadsheet"></span>';
										break;
									default:
										$file_icon = '<span class="dashicons dashicons-paperclip"></span>';
										break;
								}
							?>

								<?php
									$filename = get_the_title($doc_id);
								?>
								<a href="<?php echo wp_get_attachment_url($doc_id); ?>" download="<?php echo str_replace(' ','-',$filename); ?>">
									<?php echo $file_icon; ?>
									<div class='mcLessonh3'><?php echo get_the_title($doc_id); ?></div>
								</a>

						</div>
						<?php
					}
					?>
				</div>
			</div>
			<?php

		}
		return ob_get_clean();
	}
	public static function gradation_system(){
		ob_start();
		global $post;
    	setup_postdata($post);
		$category_detail=get_the_terms( $post->ID,'mc-class-category' );
		$cat_id = $category_detail[0]->term_id;
		$term_meta = get_option( "taxonomy_$cat_id" );
		$grad = esc_attr( $term_meta['mc_grad_term_meta'] ) ? esc_attr( $term_meta['mc_grad_term_meta'] ) : 'none';
		if( !$grad && $grad == 'none' )
			return;
	
		//echo "<div class='mcLessonGradH2'>Lesson Quiz</div>";
		switch ($grad) {
			case 'mcq':
			
				Master_Lesson_Functions::get_mcq_gradation();
				break;
			case 'confident':
				Master_Lesson_Functions::get_confident_gradation();
				break;
			case 'checkmark':
				Master_Lesson_Functions::get_checkmark_gradation();
			
				break;

			default:
				# code...
				break;
		}
	
		return ob_get_clean();
		
	}
	public static function comments_system(){
		ob_start();
		global $post;
		global $wpdb;
		$avatarID = get_user_meta( get_current_user_id(), '_classmakr_avatar_id' , true );
		$current_user_gravatar_url = ($avatarID!=NULL?wp_get_attachment_image_src( $avatarID, 'class-makr-avatar')[0]:MC_IMG.'/default.jpeg');
		?>

	    <div class="mcLessonComments">
	    	<div class="mcLessonDiscussionH2">Lesson Discussion</div>
	      <div class="mcLessonCommentsDiv">

	        	<div class="mcLessonCommentsImg"><img src="<?php echo $current_user_gravatar_url; ?>"/></div>
					<textarea name="name" placeholder="Comments" id="mc-learner-com"></textarea>
					<br><span class="class-makr-avatar-upload-ajax-error"></span>
					<input type="submit" name="" value="Post" id="mc-post-comments">
					<input type="hidden" name="lesson_id" id="mc_lesson_id" value="<?php echo $post->ID; ?>">
	      		</div>
				<div class="mcLessonDiscussion">
					
					<?php
						$comments = get_comments(array(
					        'post_id' => $post->ID, 'orderby'=>'comment_date',
					        ));
					    foreach($comments as $comment) {
					           //echo '<pre>'; print_r($comment->comment_author_email); echo "</pre>";
					        //if( $comment->comment_approved == 1 ){
					            $authorData=get_user_by('email',$comment->comment_author_email);
        		                $avatarID = get_user_meta( $authorData->ID, '_classmakr_avatar_id' , true );
        			 
            			         if(is_super_admin($authorData->ID))
            			         {
            			             $fname = get_user_meta( $authorData->ID, 'first_name', true );
            			             $fname=(strlen($fname)>0?$fname:'');
            			             $lname = get_user_meta( $authorData->ID, 'last_name', true );
            			             $lname=(strlen($lname)>0?$lname:'');
            			             $author=$fname.' '.$lname;
            			         }
            			         else
            			         {
            			             if(in_array( 'administrator', (array) $authorData->roles ))
                			         {
                			             $email=$comment->comment_author_email;
                			             $res=$wpdb->get_var("SELECT title FROM `".$wpdb->get_blog_prefix(1)."signups` WHERE user_email='".$email."' order by signup_id desc limit 1");
                                         $author=$res;
                			         }
                			         else
                			         {
                			             $author=$comment->comment_author;
                			         }
            			         }
					            $gravatar_url = Common_Functions_Controller::get_avatar_img_url($comment->comment_author_email);
						    
						        ?>
						        <div class="mcLessonDiscussionSingle">
				          			<div class="mcLessonCommentsImg"><img src="<?php echo $gravatar_url; ?>"/></div>
									<div class="mcLessonDiscussionTxt">
										<div class="mcLessonDiscussionName">
											<?php 
												echo $author; 
												$user = get_user_by( 'email', $comment->comment_author_email );  
												if ( in_array( 'administrator', (array) $user->roles ) ) {  
												    echo '<span class="class-makr-chat-role">Administrator</span>';
												}
											?>
										</div>
										<?php echo $comment->comment_content;  ?>
										<div class="mcLessonDiscussionMeta"><a href="javascript:void(0);"><?php echo Common_Functions_Controller::humanTiming( strtotime($comment->comment_date) );?> ago</a></div>
									</div>
								</div>
						        <?php
						    //}
					    }

					?>
				</div>
	    </div>
	    <script type="text/javascript">
	    	var classMakrcheckJSON = function(m) {

               if (typeof m == 'object') { 
                  try{ m = JSON.stringify(m); }
                  catch(err) { return false; } }
            
               if (typeof m == 'string') {
                  try{ m = JSON.parse(m); }
                  catch (err) { return false; } }
            
               if (typeof m != 'object') { return false; }
               return true;
            
            };
	    	
	    	
	    	
	    	jQuery("#mc-post-comments").on('click',function(){
	    	    jQuery(".class-makr-avatar-upload-ajax-error").html(' ');
	    		var val = jQuery("#mc-learner-com").val();
			    if( !val ){
			    	jQuery("#mc-learner-com").focus();
			    	return false;
			    }
			 //   if(val && val.match(/^\s+|\s+$/g)) {
			 //      jQuery("#mc-learner-com").val('');
			 //      jQuery("#mc-learner-com").focus();
			 //      return false;
			 //   }
			    var data = {
			      action: 'mc_learner_comment_update',
			      user_id: '<?php echo get_current_user_id(); ?>',
			      lesson_id: jQuery("#mc_lesson_id").val(),
			      comments: val,
			    };
			    jQuery("#mc-post-comments").val('Posting...');
			    jQuery("#mc-post-comments").attr('disabled','disabled');
			   	var ajaxurl = '<?php echo admin_url( 'admin-ajax.php' ); ?>';
			   	jQuery.ajax({
			   	    url:ajaxurl,
			   	    method:'POST',
			   	    data:data,
			   	    success:function(response)
			   	    {
			   	        jQuery("#mc-post-comments").val('Post');
			   			jQuery("#mc-learner-com").val('');
			   			jQuery("#mc-post-comments").removeAttr('disabled');
			   	        if(classMakrcheckJSON(response))
			   	        {
			   	            var obj = JSON.parse(response); 
			   	            var html='<div class="mcLessonDiscussionSingle">';
          			        html=html+'<div class="mcLessonCommentsImg"><img src="'+obj.avatar+'" width="80px" height="80px"/></div>';
					        html=html+'<div class="mcLessonDiscussionTxt">';
						    html=html+'<div class="mcLessonDiscussionName">'+obj.author;
						    html=html+obj.role;
						    html=html+'</div>';
						    html=html+obj.msg;
						    html=html+'<div class="mcLessonDiscussionMeta"><a href="javascript:void(0);">'+obj.time+'</a></div>';
					        html=html+'</div>';
				            html=html+'</div>';
				            jQuery(".mcLessonDiscussion").append(jQuery(html));
			   	        }
			   	        else
			   	        {
			   	            jQuery(".class-makr-avatar-upload-ajax-error").html(response);
			   	        }
                
			   	    }
			   	});

	    	});
        	    </script>
		<?php
		return ob_get_clean();

	}
	public function live_comment_system()
	{
	    ob_start();
		global $post;
		$avatarID = get_user_meta( get_current_user_id(), '_classmakr_avatar_id' , true );
		$current_user_gravatar_url = ($avatarID!=NULL?wp_get_attachment_image_src( $avatarID, 'class-makr-avatar')[0]:MC_IMG.'/default.jpeg');
		?>

	    <div class="mcLessonComments">
	             <div id="class-makr-chat-wrap">
	                <div class="mcLessonDiscussion" id="class-makr-chat-area">
	                    <div class='class-makr-chat-loader'><img src='<?php echo MC_IMG.'/5.gif';?>'></div>
	                    <div class="mcLessonLoadLiveOldComments-container" style="display:none;">
	                        <a href="#" class="mcLessonLoadLiveOldComments">Load Older Comments</a>
	                        <img src="<?php echo MC_IMG.'/5.gif';?>" alt="class-makr-loader" style="display:none;">
	                    </div>
	                </div>
	           </div>
	            <div class="mcLessonCommentsDiv">
	                <form class="class-makr-avatar-setup" method="post" action="" enctype="multipart/form-data">
        			    <input type="hidden" name="class-makr-avatar-src" value="<?php echo get_current_user_id()?>">
        			    <input id="class-makr-avatar-upload" type="file" style="display:none" name="class-amkr-avatar-upload" onchange="ValidateSize(this)">
    			    </form>
                    <div class="mcLessonCommentsImg"><img src="<?php echo $current_user_gravatar_url; ?>"  id="class-makr-act-avatar-upload"/>
                    
                    </div>
					<textarea name="name" placeholder="Comments" id="mc-learner-com"></textarea>
					<br><span class="class-makr-avatar-upload-ajax-error"></span>
					<!--<input type="submit" name="" value="Post" id="mc-post-comments">-->
					<input type="hidden" name="lesson_id" id="mc_lesson_id" value="<?php echo $post->ID; ?>">
	      		</div>
				
	    </div>
	    <script type="text/javascript">
	    	var classMakrcheckJSON = function(m) {

               if (typeof m == 'object') { 
                  try{ m = JSON.stringify(m); }
                  catch(err) { return false; } }
            
               if (typeof m == 'string') {
                  try{ m = JSON.parse(m); }
                  catch (err) { return false; } }
            
               if (typeof m != 'object') { return false; }
               return true;
            
            };
	    	jQuery("#mc-learner-com").on("keyup keydown",function(e){
	    	    if (e.keyCode == 13) { 
    			    jQuery(".class-makr-avatar-upload-ajax-error").html(' ');
    	    		var val = jQuery("#mc-learner-com").val();
    			    if( !val ){
    			    	jQuery("#mc-learner-com").focus();
    			    	return false;
    			    }
    			    if(val && val.match(/^\s+|\s+$/g)) {
    			       jQuery("#mc-learner-com").val('');
    			       jQuery("#mc-learner-com").focus();
    			       return false;
    			    }
    			    var data = {
    			      action: 'mc_learner_comment_update',
    			      user_id: '<?php echo get_current_user_id(); ?>',
    			      lesson_id: jQuery("#mc_lesson_id").val(),
    			      comments: val,
    			    };
    			    var ajaxurl = '<?php echo admin_url( 'admin-ajax.php' ); ?>';
    			   	jQuery.ajax({
    			   	    url:ajaxurl,
    			   	    method:'POST',
    			   	    data:data,
    			   	    success:function(response)
    			   	    {
    			   	        jQuery("#mc-post-comments").val('Post');
    			   			jQuery("#mc-learner-com").val('');
    			   			jQuery("#mc-post-comments").removeAttr('disabled');
    			   	        if(!classMakrcheckJSON(response))
    			   	        {
    			   	             jQuery(".class-makr-avatar-upload-ajax-error").html(response);
    			   	        }
                    
    			   	    }
    			   	});
    			}
	    	});
	    	
	    	
        	    </script>
		<?php
		return ob_get_clean();
	}
}
