<?php
function subscribe($api_key,$token_key,$email,$first_name) {
	$listId = getListId($api_key, $token_key);
	$parts = explode("@", $email);
	$fname = $parts[0];	
	$name   = ($first_name !='') ? $first_name : $fname;
	$contact=  array();
	$contact = array(
						'email_addresses' => array(
							array('email_address' => $email)
						),
						'first_name' => $name,
						'lists' => array(
							array(
								'id' => $listId
							)
						)
					);
	$curl = curl_init('https://api.constantcontact.com/v2/contacts?api_key='.rawurlencode($api_key).'&action_by=ACTION_BY_VISITOR');
	$header = array(
		'Content-Type: application/json',
		'Authorization: Bearer '.$token_key
	);
	curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
	curl_setopt($curl, CURLOPT_TIMEOUT, 10);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
	//curl_setopt($curl, CURLOPT_FORBID_REUSE, 1);
	//curl_setopt($curl, CURLOPT_FRESH_CONNECT, 1);
	curl_setopt($curl, CURLOPT_POST, 1);
	curl_setopt($curl, CURLOPT_POSTFIELDS, json_encode($contact));
	curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0);
	curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, 0);
	$response = curl_exec($curl);
	curl_close($curl);
	$res_arr = json_decode($response);
	//echo "<pre>"; print_r($res_arr); echo "</pre>";
	if($res_arr->status){
		return $res_arr->status;
	} else {
		return false;
	}
				
}


function getListId($apikey,$token_key){
	$curl = curl_init('https://api.constantcontact.com/v2/lists?api_key='.$apikey);//key
	$header = array();
	$header[] = 'Authorization: Bearer '.$token_key;//token
	$header[] = 'X-Originating-Ip '.$_SERVER['SERVER_ADDR'];	//IP
	curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
	curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
	$response = curl_exec($curl);
	curl_close($curl);
	$result_arr = json_decode($response);
	//echo "<pre>"; print_r($result_arr);echo "</pre>";
	return $result_arr[0]->id;
	
}


