<?php get_header(); ?>

<?php
global $wp;
$request = $wp->request;
$request_arr  = explode("/",$request);
if( $request_arr[0] != 'mc-class-category' )
	return;

$lesson_details = get_term_by('slug', $request_arr[1], 'mc-class-category');
$t_id = $lesson_details->term_id;

$term_meta = get_option( "taxonomy_$t_id" );
$org_term_meta = $term_meta;
add_filter( 'body_class', function( $classes ) {
	return array_merge( $classes, array( 'mc-class-active-category') );
} );
?>
<link rel="stylesheet" href="<?php echo MC_CSS; ?>/stellar.css" type="text/css" media="screen"/>
<link rel="stylesheet" href="<?php echo MC_CSS; ?>/stellar-font-awesome.css" type="text/css">
<script src="<?php echo MC_JS; ?>/jquery.mCustomScrollbar.js" type="text/javascript"></script> 
<script src="<?php echo MC_JS; ?>/videoPlayer.js" type="text/javascript"></script>
<script src="<?php echo MC_JS; ?>/Playlist.js" type="text/javascript"></script>
<script src="<?php echo MC_JS; ?>/iphone-inline-video.js" type="text/javascript"></script>
<script src="https://player.vimeo.com/api/player.js"></script>
<div class="mcContMainWrapper">
	<div class="mcContSubWrapper">
		<div class="mcContFull78">
			<?php
			$mc_nav_on_pages = (get_option('mc_nav_on_pages')) ? get_option('mc_nav_on_pages') : 'disable';

			if( is_user_logged_in() && $mc_nav_on_pages == 'enable' ){
				global $current_user;
				$img_url = Common_Functions_Controller::get_avatar_img_url( $current_user->user_email );

				?>
				<div class="mcUserAccNavUL mcUserAccNavUL-front">
					<div class="mcUserAccNavLILogon"><img src="<?php echo $img_url; ?>" />Hello <?php echo $current_user->display_name; ?></div>
					<div class="mcUserAccNavLI"><a href="<?php echo site_url();?>/mc-dashboard" target="_blank;">My Dashboard</a></div>
					<div class="mcUserAccNavLI"><a href="<?php echo wp_logout_url( home_url().'/mc-login/?logout=success' );?>">Logout</a></div>
				</div>
				<?php
			}

			?>
			<div id="test-dropbox-video"></div>
		  	<div class="mcContMain78">
				<div id="term-<?php echo $t_id; ?>" class="mc_class_cat_box">
					<div class="mc-class-video-area">
						
						<?php
							$vid_url = esc_attr( $term_meta['mc_cat_vid_url_term_meta'] ) ? esc_attr( $term_meta['mc_cat_vid_url_term_meta'] ) : '';
							$vid_type = esc_attr( $term_meta['mc_cat_vid_type_term_meta'] ) ? esc_attr( $term_meta['mc_cat_vid_type_term_meta'] ) : 'youtube';
							$vid_src = Common_Functions_Controller::generate_iframe( $vid_url, $vid_type );

							$img_type = esc_attr( $org_term_meta['mc_cat_vid_thumb_image_type_term_meta'] ) ? esc_attr( $org_term_meta['mc_cat_vid_thumb_image_type_term_meta'] ) : 'default';
							if($img_type == 'default'){
								$posterImg = MC_IMG."/poster.jpg";
							}elseif($img_type == 'featured'){
								$posterImg = wp_get_attachment_url($org_term_meta['mc_cat_cover_term_meta']);
							}elseif($img_type == 'new') {
								$posterImg = wp_get_attachment_url($org_term_meta['mc_cat_vid_thumb_image_term_meta']);
							}

							if( $vid_type == 'whistia' ){ ?>
								<script>
								window._wq = window._wq || [];
								_wq.push({
								  id: "<?php echo $vid_src; ?>",
								  options: {
								  	smallPlayButton: true,
								    videoFoam: true,
								    playerColor: "ff0000",
								    playButton: true,
								    settingsControl: true,
								    stillUrl: "<?php echo $posterImg; ?>",
								    volumeControl: true,
								    wmode: "transparent",
								    endVideoBehavior: "reset"
								  }
								});
								</script>
								<script charset="ISO-8859-1" src="//fast.wistia.com/assets/external/E-v1.js" async></script>
								<div class="mc-class-video-area mcWhistiaVideo wistia_embed wistia_async_<?php echo $vid_src; ?>" style="width:620px;height:340px;"></div>
								<?php
								// echo $vid_src = Common_Functions_Controller::generate_iframe( $vid_url, $vid_type );
								// echo '<iframe src="'.$vid_src.'" allowtransparency="true" frameborder="0" scrolling="no" class="wistia_embed" name="wistia_embed" allowfullscreen mozallowfullscreen webkitallowfullscreen oallowfullscreen msallowfullscreen width="620" height="349"></iframe>';
								// echo '<script src="//fast.wistia.net/assets/external/E-v1.js" async></script>';

							}else{
						?>
								<div id="mc-stellar-class-video-player"></div>
						<?php } ?>
						
					</div>
					<div class="mc_class_title mc_class_H2">
						<?php echo $lesson_details->name; ?>
					</div>
					<?php
					$posts_arr = get_posts(array(
							'post_type' => 'mc-class',
							'orderby' => 'menu_order',
							'tax_query' => array(
								array(
								'taxonomy' => 'mc-class-category',
								'field' => 'term_id',
								'terms' => $t_id)
							),
							'posts_per_page' => -1
							)

						);
					?>
		     		
		     			<?php
		                    $price = esc_attr( $term_meta['mc_cat_price_term_meta'] ) ? esc_attr( $term_meta['mc_cat_price_term_meta'] ) : 'FREE';
		                    $payType= esc_attr( $term_meta['mc_cat_payment_interval_format_term_meta']) ? esc_attr($term_meta['mc_cat_payment_interval_format_term_meta']) :'one-time';
		                    $currency = (get_option('mc_cls_currency')) ? get_option('mc_cls_currency') : '';
		                    $currency_arr = explode("-",$currency);
		                    $subscribed = false;
		                    if( is_user_logged_in() ){
		                    	$args = array(
									'posts_per_page'   => -1,
									'meta_key'         => '_mc_pay_user_id',
									'meta_value'       => get_current_user_id(),
									'post_type'        => 'mc_class_payment',
									'post_status'      => 'publish',
								);
								$payments_array = get_posts( $args );
								if(count($payments_array)>0):
								$subTemp=array();
								foreach ($payments_array as $payment) {
								   
									$term_id = get_post_meta( $payment->ID, '_mc_pay_course_id', true );
									$bundle_id = get_option( '_mc_class_bundle_id' );
									
									if( $term_id == $bundle_id ){
										$mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');
										if(is_array($mc_cls_bundle_package_product) && in_array( $t_id, $mc_cls_bundle_package_product )){
										    $subscriFlag = '1';
											$stat=get_post_meta($payment->ID,'_mc_order_payment_status',true);
    										if($stat=='cancelled')
    										 {
    										     $subscriFlag='0';
    										 }
    									
    										 array_push($subTemp,$subscriFlag);
										
										}
									}
									if( $term_id == $t_id ){
										 $subscriFlag = '1';
										 $stat=get_post_meta($payment->ID,'_mc_order_payment_status',true);
            					         $stat2=get_post_meta($payment->ID,'_mc_order_status',true);
										 
										 $orderStat=array();
				                    
        				                    if(strlen($stat)>0)
                    				        {
                    				            $orderStat[]=$stat;
                    				        }
                    				        
                    				        if(strlen($stat2)>0)
                    				        {
                    				            $orderStat[]=$stat2;
                    				        }
										 
										    if(in_array('cancelled',$orderStat))
                    					    {
                    					        $subscriFlag = '0';
                    					    }
										 
								        array_push($subTemp,$subscriFlag);
										
									}
								}
								if(in_array('1',$subTemp))
								{
								    $subscribed=true;
								}
								endif;
		                    }
		                  
    		                 	if( !$subscribed )
    		                 	{   
                                echo '<div class="mcClassAccessBtn">';
		                 		if( $price != 'FREE' ){  
		                 		 
		                 		    $tempformat=($payType=='one-time'?'':' / '.substr($payType,0,-1));
                                    $priceText=$price.$tempformat;
		                 		?>      
                                <span class="class-makr-class-price-area"><?php echo 'Price: '.$currency_arr[1].$priceText;?></span>
		     					<a href="<?php echo site_url().'/mc-registration/?classId='. base64_encode($t_id); ?>"><?php echo $term_meta['mc_cat_price_btn_txt_term_meta']; ?></a>
		     		        	<?php
		     					}else{
		     						?>
		     					<a href="<?php echo site_url().'/mc-registration/?classId='. base64_encode($t_id); ?>"><?php echo $term_meta['mc_cat_price_btn_txt_term_meta'].' '.$price; ?></a>
		     						<?php
		     					}
		     					echo'</div>';
		     					
		     					?>
		     				
		     					
		     					<?php
		     					
		     					$mc_cls_bundle_on_class_details = get_option('mc_cls_bundle_on_class_details') ? get_option('mc_cls_bundle_on_class_details') : 'disable';
			     				if( $mc_cls_bundle_on_class_details == 'enable' ){

			     					$mc_cls_bundle_package_product = get_option('mc_cls_bundle_package_product');

			     					if( is_array($mc_cls_bundle_package_product) ){

			     						if( in_array( $t_id, $mc_cls_bundle_package_product ) ){

			     							$mc_cls_bundle_price_txt = get_option('mc_cls_bundle_price_txt') ? get_option('mc_cls_bundle_price_txt') : 'Get access to all classes';
			     							$mc_cls_bundle_price = get_option('mc_cls_bundle_price') ? get_option('mc_cls_bundle_price') : 'FREE';
                                            $payment_type= get_option('mc_cls_bundle_package_payment_type') ? get_option('mc_cls_bundle_package_payment_type') : 'one-time';
                                            
                                            $paymentTypeText=($payment_type=='one-time'?'':' / '.substr($payment_type,0,-1));
                                            
			     							if( $mc_cls_bundle_price != 'FREE' ){
			     								?>
			     									<span class="class-makr-bundle-option"> Or <a href="<?php echo site_url().'/mc-registration/?classId='. base64_encode(get_option( '_mc_class_bundle_page_id' )); ?>"><?php echo $mc_cls_bundle_price_txt.' for: '.$currency_arr[1].$mc_cls_bundle_price.$paymentTypeText; ?></a></span>
			     								<?php
			     							}else{
			     								?>
			     								   <span class="class-makr-bundle-option">	Or <a href="<?php echo site_url().'/mc-registration/?classId='. base64_encode(get_option( '_mc_class_bundle_page_id' )); ?>"><?php echo $mc_cls_bundle_price_txt.' for: '.$mc_cls_bundle_price; ?></a></span>
			     								<?php
			     							}

			     						}
			     					}
			     				}
		     				}


		     			?>
		     			<?php if(empty($posts_arr))
		     			{
		     				echo '<span style="text-align:center; width:100%; margin-top:30px;display:block;">The admin has not added any Lesson plans to this package yet.</span>';
		     			}?>
		     		
				<?php
					if( $term_meta['mc_short_desc_term_meta'] ){
						echo '<div class="mcLessonCount">'.stripslashes($term_meta['mc_short_desc_term_meta']).'</div>';
					}
				?>


					<?php
						

						if(!empty($posts_arr))
						{
							$count = 1;
					?>

				    	<div class="mc_class_all_posts">
				    	    <div class="mc_class_title mc_class_H3">Lesson Plan</div>
				    		<div class="mc_class_UL">
				    		    <?php
				    				foreach ($posts_arr as $post_single) { 
				    				 $url=Common_Functions_Controller::classLessonAccessLink($subscribed,$t_id,$post_single->ID);
				    				 $liveStatus=Common_Functions_Controller::lessonLiveStatus( $post_single->ID );
				    				 $liveStatus=($liveStatus=='active'?'<img src="'.MC_IMG.'/blink.gif" alt="class-makr-live" class="class-makr-live-icon">':'');
				    				 /*blink.gif*/
				    				?>
				    				<div class="mc_class_LI">
				    					<span class="mc_class_post-count"><?php echo str_pad($count, 2, '0', STR_PAD_LEFT); ?><?php echo $liveStatus;?></span> 
				    					<div class="mc_class_success_log">
				    					 <div class="mc_class_text_area">
				    					<span class="mc_class_post-title"><a href="<?php echo $url;?>"><?php echo $post_single->post_title; ?></a></span>
				    					<div class="mc_class_P"><?php echo strlen(strip_tags($post_single->post_content)) > 250 ? substr(strip_tags($post_single->post_content),0,250)."..." : strip_tags($post_single->post_content); ?></div>
				    					</div>
				    					<div class="mc_class_icon">
                                            <?php echo $grade=Common_Functions_Controller::classLessonGrade($subscribed,$t_id,$post_single->ID);?>
                                        </div>
				    					</div>
				    				</div>
				    			<?php
				    				$count++;
				    				} ?>
				    		</div>
				    	</div>
					<?php
						}					?>

					<div class="clearfixMCclass"></div>
						<?php if($term_meta['mc_cat_cover_term_recomended_id']){ ?>
						<div class="clearfixMCclass mCavailable">
							<h2>RECOMMENDED FOR YOU</h2>
				            <ul>
				            	<?php
				            		foreach( $term_meta['mc_cat_cover_term_recomended_id'] as $mc_cat_cover_term_recomended_class ){
						      			$mc_cat_cover_term_recomended_id = $mc_cat_cover_term_recomended_class;
				        				$term_meta = get_option( "taxonomy_$mc_cat_cover_term_recomended_id" );

				        				$term_details = get_term_by('id', $mc_cat_cover_term_recomended_class, 'mc-class-category');
				        				$cover_id = $term_meta['mc_cat_cover_term_meta'];
				            	?>
				            	<li>
					                <div class="mCavailableMain">
										<a href="<?php echo get_term_link( $term_details->slug, $term_details->taxonomy ); ?>"></a>

										<div class="mCavailableImgWrap">
											<div class="mCavailableImgmain">

												<?php
						      				if( wp_get_attachment_url($cover_id) ){
						      					$img_url = wp_get_attachment_url($cover_id);
						      				}else{
						      					$img_url = MC_IMG.'/image-no.png';
						      				}
								      	?>
							            <img src="<?php echo $img_url; ?>" alt="" />

											</div>
										</div>


										<div class="mCavailableMainCaption">
											<h3><?php echo $term_details->name; ?></h3>
										</div>
					                </div>
								</li>
								<?php
									}
							?>
							</ul>
						</div>
						<?php
						}
						?>
				</div>
			</div>
		</div>
	</div>
</div>
<?php
$img_type = esc_attr( $org_term_meta['mc_cat_vid_thumb_image_type_term_meta'] ) ? esc_attr( $org_term_meta['mc_cat_vid_thumb_image_type_term_meta'] ) : 'default';

if($img_type == 'default'){

	$posterImg = MC_IMG."/poster.jpg";

}elseif($img_type == 'featured'){
	
	$posterImg = wp_get_attachment_url($org_term_meta['mc_cat_cover_term_meta']);

}elseif($img_type == 'new') {

	$posterImg = wp_get_attachment_url($org_term_meta['mc_cat_vid_thumb_image_term_meta']);
}

$vid_url = esc_attr( $org_term_meta['mc_cat_vid_url_term_meta'] ) ? esc_attr( $org_term_meta['mc_cat_vid_url_term_meta'] ) : '';
$vid_type = esc_attr( $org_term_meta['mc_cat_vid_type_term_meta'] ) ? esc_attr( $org_term_meta['mc_cat_vid_type_term_meta'] ) : 'youtube';
$vid_src = Common_Functions_Controller::generate_video_url( $vid_type, $vid_url ); 

if( $vid_type == 'youtube' ){

	$videoType = 'youtube';

}elseif( $vid_type == 'vimeo' ) {
	
	$videoType = 'vimeo';

}else{

	$videoType = 'HTML5';
}

?>
<script type="text/javascript">
	jQuery('.mc-class-cat-load-more').click(function(){
		jQuery(this).addClass('mcLoadAct');
		jQuery('.mc-class-cat-hide-at-load').addClass('mcLoadAct');
	});
</script>
<script type="text/javascript" charset="utf-8">
	jQuery(function($){
	    $("document").ready(function(){
	        
	        videoPlayer = $("#mc-stellar-class-video-player").Video({                       
					instanceName:"player1",
					instanceTheme:"<?php echo get_option( 'mc_player_theme' ) ? get_option( 'mc_player_theme' ) : 'light'; ?>",
					playerLayout: "fixedSize",
					playerOrientation:"<?php echo get_option( 'mc_player_text_orientation' ) ? get_option( 'mc_player_text_orientation' ) : 'false'; ?>",
					autohideControls:3,
					hideControlsOnMouseOut:true,
					videoPlayerWidth:768,
					videoPlayerHeight:432,
					videoRatio: 16/9,
					videoRatioStretch: true,
		            iOSPlaysinline: true,
		            autoplay:<?php echo get_option( 'mc_player_autoplay' ) ? get_option( 'mc_player_autoplay' ) : 'false'; ?>,
					colorAccent:"<?php echo get_option('mc_player_color_acent') ? get_option('mc_player_color_acent') : '#ff0000'; ?>",
					videoAnimationTime: 350,
					playSpecificVideo: 0,
					progressBarThickness: 3,
					progressBarThicknessOnMouseover: 6,
					tooltipFontSize:12,
					videoPlayerShadow:"<?php echo get_option( 'mc_player_shadow_effect' ) ? get_option( 'mc_player_shadow_effect' ) : 'effect1' ;?>",
					loadRandomVideoOnStart:false,
					shuffle:false,
					posterImg:"<?php echo $posterImg; ?>", 
					posterImgOnVideoFinish:"<?php echo $posterImg; ?>",
					onFinish:"Stop video",
					nowPlayingText:true,
					showAllControls:true,
					allowSkipAd:true,
					infoShow:false,
					nextShow:false,
					rewindShow:<?php echo get_option( 'mc_player_rewind' ) ? get_option( 'mc_player_rewind' ) : 'true'; ?>,
					qualityShow:false,
					lightBox:false,
					playlist:"Off",
					playlistBehaviourOnPageload:"opened (default)",				
					youtubeControls:"custom controls",
					youtubeSkin:"dark",
					youtubeColor:"white",
					youtubeQuality:"default",
					youtubeShowRelatedVideos:false,
					HTML5VideoQuality:"HD",
					preloadSelfHosted:"none",
					rightClickMenu:false,
					hideVideoSource:true,
					shareShow:false,
					logoShow:false,
					embedShow:false,
					showGlobalPrerollAds: false,
					globalPrerollAds: "url1;url2;url3;url4;url5",
					globalPrerollAdsSkipTimer: 5,
					globalPrerollAdsGotoLink: "https://bsitemaker.com/",
					youtubePlaylistID:"",
					youtubeChannelID:"",
				    videos:[
        				{
        					videoType:"<?php echo $videoType; ?>",
        					title:"<?php echo $lesson_details->name; ?>",
        					<?php if( $videoType == 'youtube' ){ ?>
        					youtubeID: "<?php echo $vid_src; ?>",
        					<?php }elseif( $videoType == 'vimeo' ){ ?>
        					vimeoID: "<?php echo $vid_src; ?>",
        					<?php }else{ ?>
        					mp4HD:"<?php echo htmlspecialchars_decode($vid_src); ?>",
        					<?php } ?>
        					enable_mp4_download:false,
        					imageUrl:"<?php echo $posterImg; ?>",
        					imageTimer:4,
        					thumbImg:"<?php echo $posterImg; ?>",
        				}]
				
			});
	        
	    });
	});
</script>
<?php get_footer(); ?>
